﻿using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGrid_UltraComboEditor
{
    public partial class Form1 : Form
    {
        private DataTable table;
        public Form1()
        {
            InitializeComponent();
            table = createTable();

        }
        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = createTable();

            this.ultraComboEditor1.DataSource = dt;
            this.ultraComboEditor1.DisplayMember = "Category";
            this.ultraGrid1.DataSource = createData();
        }
        private DataTable createTable()
        {
            int i = 0;
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Category", typeof(string));
            table.Columns.Add("Deleted", typeof(bool));          
                        
            table.Rows.Add(++i, "Electronics", false);
            table.Rows.Add(++i, "Personal Care", true);
            table.Rows.Add(++i,"Smartphones", false);           
           
            return table;
        }
        private ObservableCollection<Data> createData()
        {
            int i = 0;
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            data.Add(new Data() { ID = ++i, Name = "Ben" });
            data.Add(new Data() { ID = ++i, Name = "Sam" });
            data.Add(new Data() { ID = ++i, Name = "Tom" });
            data.Add(new Data() { ID = ++i, Name = "John", Category = "Personal Care" });
            return data;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Category"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns["Category"].EditorComponent = this.ultraComboEditor1;
        }
       
        private void ultraGrid1_BeforeCellListDropDown(object sender, Infragistics.Win.UltraWinGrid.CancelableCellEventArgs e)
        {

            var cellValue = e.Cell.Value;
            for (int i = ((DataTable)ultraComboEditor1.DataSource).Rows.Count - 1; i >= 0; i--)
            {
                DataRow dr = ((DataTable)ultraComboEditor1.DataSource).Rows[i];
                if (dr.ItemArray[2].ToString() == "True")
                {
                    dr.Delete();
                }

            }
            ((DataTable)ultraComboEditor1.DataSource).AcceptChanges();
            if (cellValue != null)
            {
                var row = getRowIfTrue(cellValue.ToString());
                if(row != null)
                {
                    ((DataTable)ultraComboEditor1.DataSource).ImportRow(row);
                    ((DataTable)ultraComboEditor1.DataSource).DefaultView.Sort = "ID desc";
                }
            }
       
        }
        private DataRow getRowIfTrue(string value)
        {
            foreach (DataRow row in table.Rows)
            {
                if (row.ItemArray[1].ToString() == value)
                {
                    return row;
                }
            }
            return null;
        }
    }
    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Category { get; set; }
    }
}
